package Stage3D;
import javax.media.j3d.*;
import javax.vecmath.*;
import java.util.Enumeration;
import java.util.Date;
import java.util.Collection;
import java.util.Iterator;

class AngleInterpolator extends Interpolator
{
	protected WakeupOnElapsedFrames wup = null;
	private Collection actors;

	public AngleInterpolator(Collection actors)
	{
		this.actors = actors;
		Alpha alpha = new Alpha(1,0);
		setAlpha(alpha);
	}
	public void initialize()
	{
		super.initialize();
		wup = new WakeupOnElapsedFrames(1);
		//wakeupOn(wup);
		setEnable(false);
	}
	public void processStimulus(Enumeration criteria)
	{
		Object tmp;
		while(criteria.hasMoreElements())
		{
			tmp = criteria.nextElement();
			if (!(tmp instanceof WakeupOnElapsedFrames))
				continue;
			Iterator list = actors.iterator();
			Actor actor;
			double t;
			Vector3d vec = new Vector3d();
			t = getAlpha().value();
			while (list.hasNext())
			{
				actor = (Actor)(list.next());
				switch (actor.getAngFlag())
				{
				case 2:
					Vector3d d = new Vector3d();
					d.sub(actor.getOldAngle(), actor.getAngle());
					d.x = d.x % (Math.PI*2);
					d.y = d.y % (Math.PI*2);
					d.z = d.z % (Math.PI*2);
					if (d.x >= Math.PI) d.x -= Math.PI*2;
					if (d.x < -Math.PI) d.x += Math.PI*2;
					if (d.y >= Math.PI) d.y -= Math.PI*2;
					if (d.y < -Math.PI) d.y += Math.PI*2;
					if (d.z >= Math.PI) d.y -= Math.PI*2;
					if (d.z < -Math.PI) d.y += Math.PI*2;
					d.add(actor.getAngle());
					actor.setOldAngle(d);
					vec.interpolate(actor.getOldAngle(), actor.getAngle(),t);
					actor.transAngle(vec);
					actor.setAngFlag(3);

					break;
				case 3:
					vec.interpolate(actor.getOldAngle(), actor.getAngle(),t);
					actor.transAngle(vec);
					break;
				case -1:
					actor.setOldAngle(actor.getAngle());
					actor.transAngle(actor.getAngle());
					actor.setAngFlag(0);
					break;
				}
			}
			
			if (getAlpha().finished()) setEnable(false);
			wakeupOn(wup);
		}
	}
	
	public void move(boolean b)
	{
		if (b)
		{
			getAlpha().setStartTime((new Date()).getTime());
			setEnable(true);
		}else{
			setEnable(false);
		}
	}
}
