package Stage3D;
import javax.media.j3d.*;
import javax.vecmath.*;
import java.util.Enumeration;
import java.util.Date;
import java.util.Collection;
import java.util.Iterator;

class PositionInterpolator extends Interpolator
{
	protected WakeupOnElapsedFrames wup = null;
	private Collection actors;

	public PositionInterpolator(Collection actors)
	{
		this.actors = actors;
		Alpha alpha = new Alpha(1,0);
		setAlpha(alpha);
	}
	public void initialize()
	{
		super.initialize();
		wup = new WakeupOnElapsedFrames(1);
		//wakeupOn(wup);
		setEnable(false);
	}
	public void processStimulus(Enumeration criteria)
	{
		Object tmp;
		while(criteria.hasMoreElements())
		{
			tmp = criteria.nextElement();
			if (!(tmp instanceof WakeupOnElapsedFrames))
				continue;
			Iterator list = actors.iterator();
			Actor actor;
			double t;
			Vector3d vec = new Vector3d();
			t = getAlpha().value();
			while (list.hasNext())
			{
				actor = (Actor)(list.next());
				switch (actor.getPosFlag())
				{
				case 2:
					vec.interpolate(actor.getOldPosition(), actor.getPosition(),t);
					actor.transPosition(vec);
					actor.setPosFlag(3);
					break;
				case 3:
					vec.interpolate(actor.getOldPosition(), actor.getPosition(),t);
					actor.transPosition(vec);
					break;
				case -1:
					actor.setOldPosition(actor.getPosition());
					actor.transPosition(actor.getPosition());
					actor.setPosFlag(0);
					break;
				}
			}
			
			if (getAlpha().finished()) setEnable(false);
			wakeupOn(wup);
		}
	}
	
	public void move(boolean b)
	{
		if (b)
		{
			getAlpha().setStartTime((new Date()).getTime());
			setEnable(true);
		}else{
			setEnable(false);
		}
	}
}
